

#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fakemeta>
#include <fakemeta_util>
#include <fun>

#define PLUGIN "Vote Map"
#define VERSION "1.1"
#define AUTHOR "Emp`"

#define FORCE_CHANGE_TARGETNAME "changelevel"
#define FORCE_ROCKTHEVOTE "rockthevote"
#define RANDOM "@random"
#define EMPTY ""
#define SCALE 0.5

new bool:VoteMap = false
new bool:changed = false
new count = 0, loaded = 0, random_count = 0

new mapname[64]
new configDir[128], fileDir[128], file[128], random_file[128]

public plugin_init() 
{
	register_plugin(PLUGIN,VERSION,AUTHOR)

	register_cvar("Vote_Map_Plugin",VERSION,FCVAR_SERVER|FCVAR_SPONLY)
	set_cvar_string("Vote_Map_Plugin",VERSION)

	register_clcmd("say", "say_event")
	register_clcmd("say_team","say_event")
	register_event("DeathMsg", "DeathMsg", "a")

	register_forward(FM_Touch,"entity_touch")

	set_task(5.0,"check_map")
	changed = false
}
public plugin_precache()
{
	get_mapname(mapname,63)
	get_configsdir(configDir,127)
	format(fileDir,127,"%s/vote_map/",configDir)
	format(file,127,"%s/vote_map/%s.cfg",configDir,mapname)
	format(random_file,127,"%s/vote_map/random_maps.cfg",configDir)

	if(containi(mapname,"vote_")!=-1)
		VoteMap = true
	else
		VoteMap = false

	if(!dir_exists(fileDir)){
		mkdir(fileDir)
	}
	new line[255]
	if(!file_exists(random_file)){
		format(line, 254, "// List maps here that you want to replace %s in the other map files",RANDOM)
		write_file(random_file, line,-1)
		write_file(random_file, "de_dust",-1)
	}
	if(VoteMap){
		set_task(1.0,"write_how_many")
		//lets find which ones we need to load
		new charnum, sprite_precache[256], Left[51], Right[1501], bool:stop = false

		for(new i=0; i<=file_size(file, 1); i++){
			read_file(file,i,line,254,charnum)
			while(equali(line,"//",2) || equali(line,EMPTY)){
				stop = true
				break
			}
			if(stop){
				stop = false
				continue
			}
			strbreak(line, Left, 50, Right, 1500)
			if(ValidMap(Left)>0){
				format(sprite_precache,255,"sprites/vote_map/%s.spr",Left)
				precache_model(sprite_precache)
			}
		}
		for(new i=0; i<=file_size(random_file, 1); i++){
			read_file(random_file,i,line,254,charnum)
			while(equali(line,"//",2) || equali(line,EMPTY)){
				stop = true
				break
			}
			if(stop){
				stop = false
				continue
			}
			strbreak(line, Left, 50, Right, 1500)
			if(ValidMap(Left)>0){
				format(sprite_precache,255,"sprites/vote_map/%s.spr",Left)
				precache_model(sprite_precache)
			}
		}
	}
}
public write_how_many()
{
	new vote_ent = -1, how_many = 0, target[31], line[255]
	while((vote_ent = fm_find_ent_by_tname(vote_ent, FORCE_CHANGE_TARGETNAME)))
	{
		pev(vote_ent, pev_target, target, 30)
		if(!equali(target,"none"))
			continue
		how_many++
	}
	if(how_many==0)
		return
	if(!file_exists(file)){
		format(line, 254, "// List full map names here, or use %s for a random map from %s",RANDOM,random_file)
		write_file(file, line,-1)
		for(new i=0; i<how_many; i++)
			write_file(file, RANDOM,-1)
	}
}

public entity_touch(ent1, ent2)
{
	if(pev_valid(ent1) && pev_valid(ent2) && (is_user_alive(ent1) || is_user_alive(ent2)) && !changed){
		new targetname[15]
		new mapchange=0, rockthevote=0
		pev(ent1, pev_targetname, targetname, 14)
		if(equal(targetname, FORCE_CHANGE_TARGETNAME) && ent2 < 33)
			mapchange = 1
		else {
			pev(ent2, pev_targetname, targetname, 14)
			if(equal(targetname, FORCE_CHANGE_TARGETNAME) && ent1 < 33)
				mapchange = 2
		}
		if(mapchange) {
			new ent
			new target[32]
			ent = (mapchange == 1) ? ent1 : ent2
			pev(ent, pev_target, target, 31)
			if(strlen(target)){
				new exec[128]
				format(exec,128, "amx_map %s",target)
				console_cmd(0,exec)
				if(VoteMap){
					client_print(0, print_chat, "%s won the vote.", target)
					client_print(0, print_chat, "%s won the vote.", target)
					client_print(0, print_chat, "%s won the vote.", target)
					client_print(0, print_chat, "%s won the vote.", target)
					client_print(0, print_chat, "%s won the vote.", target)
				}
				changed = true
			}
			return FMRES_SUPERCEDE
		}
		pev(ent1, pev_targetname, targetname, 14)
		if(equal(targetname, FORCE_ROCKTHEVOTE) && ent2 < 33)
			rockthevote = 1
		else {
			pev(ent2, pev_targetname, targetname, 14)
			if(equal(targetname, FORCE_ROCKTHEVOTE) && ent1 < 33)
				rockthevote = 2
		}
		if(rockthevote) {
			console_cmd(0,"dmap_rockthevote")
			if(VoteMap){
				client_print(0, print_chat, "Rocking The Vote...")
				client_print(0, print_chat, "Rocking The Vote...")
				client_print(0, print_chat, "Rocking The Vote...")
				client_print(0, print_chat, "Rocking The Vote...")
				client_print(0, print_chat, "Rocking The Vote...")
			}
			changed = true
			return FMRES_SUPERCEDE
		}
	}
	return FMRES_IGNORED
}

public check_map()
{
	if(VoteMap){
		//lets load some maps
		new line[255]
		new vote_ent = -1, target[31], Float:origin[3]
		new charnum, random_size = file_size(random_file, 1)
		new Left[51], Right[1501], sprite_ent, sprite[256], bool:random_map

		while((vote_ent = fm_find_ent_by_tname(vote_ent, FORCE_CHANGE_TARGETNAME)) && count<file_size(file,1) && random_count<file_size(random_file,1))
		{
			pev(vote_ent, pev_target, target, 30)
			if(!equali(target,"none"))
				continue

			random_map = false

			read_file(file,count,line,254,charnum)
			while(equali(line,"//",2)){
				count++
				read_file(file,count,line,254,charnum)
			}
			strbreak(line, Left, 50, Right, 1500)
			while(equali(Left,EMPTY) || equali(Left,RANDOM)){
				random_map = true
				read_file(random_file,random_num(0,random_size),line,254,charnum)
				while(equali(line,"//",2)){
					read_file(random_file,random_num(0,random_size),line,254,charnum)
				}
				strbreak(line, Left, 50, Right, 1500)
			}

			//ok, we should have a valid map by now, but lets make sure the server has it
			switch(ValidMap(Left))
			{
				case 1,2:{
					//lets make sure that its not on the map already
					if(CheckDups(Left)){
						if(!random_map)
							count++
						vote_ent = -1
					}
					else{
						if(ValidMap(Left)==2)
							set_pev(vote_ent, pev_targetname, FORCE_ROCKTHEVOTE)
						else
							set_pev(vote_ent, pev_target, Left)

						sprite_ent = fm_create_entity("info_target")

						fm_get_brush_entity_origin(vote_ent, origin)
						fm_entity_set_origin(sprite_ent, origin)

						format(sprite, 255, "sprites/vote_map/%s.spr",Left)
						fm_entity_set_model(sprite_ent,sprite)
						set_pev(sprite_ent, pev_scale, SCALE)

						if(random_map)
							random_count++
						count++
						loaded++
					}
				}
				case -1:{
					vote_ent = -1
					log_amx("Invalid Map : %s : Sprite File not found",Left)
				}
				default:{
					vote_ent = -1
					log_amx("Invalid Map : %s : Map File not found",Left)
				}
			}
		}
		log_amx("Loaded %d Change Maps",loaded)
	}
}
CheckDups(const MapName[])
{
	new vote_ent = -1, target[31]
	if(equali(MapName,FORCE_ROCKTHEVOTE)){
		while((vote_ent = fm_find_ent_by_tname(vote_ent, FORCE_ROCKTHEVOTE)))
			return 1
	}
	else{
		while((vote_ent = fm_find_ent_by_tname(vote_ent, FORCE_CHANGE_TARGETNAME)))
		{
			pev(vote_ent, pev_target, target, 30)
			if(equali(target,MapName))
				return 1
		}
	}
	return 0
}
ValidMap(const MapName[])
{
	if(equali(MapName,FORCE_ROCKTHEVOTE)){
		return 2
	}
	new sprite_file[128]
	format(sprite_file,127,"sprites/vote_map/%s.spr",MapName)
	if(is_map_valid(MapName)){
		if(file_exists(sprite_file))
			return 1
		else
			return -1
	}
	return 0
}

public say_event(id) 
{
	if( !is_user_alive(id) && VoteMap && !changed )
	{
		spawn_func(id)
	}
}

public DeathMsg()
{
	new id = read_data(2)

	if(VoteMap && !changed)
		spawn_func(id)
}

public spawn_func(id)
{
	if(get_user_team(id)<1)
		return
	/* Spawn the player twice to avoid the HL engine bug */
	set_task(0.5,"player_spawn",id)
	set_task(0.7,"player_spawn",id)

	/* Then give them a suit and a knife */
	set_task(0.9,"player_giveitems",id)
}

public player_giveitems(id)
{
	if(is_user_alive(id)){
		give_item(id, "item_suit")
		give_item(id, "weapon_knife")
	}
}

public player_spawn(id)
{
	spawn(id)
}

